Loading...
Searching...
No Matches
BALL::CharmmFF Class Reference
Molecular Modeling » Molecular Mechanics » CHARMM Force Field.

`#include <BALL/MOLMEC/CHARMM/charmm.h>`

Inheritance diagram for BALL::CharmmFF:

## Classes

struct | Option
struct | Default

## Public Member Functions

Constructors and Destructors
| CharmmFF ()
| CharmmFF (System &system)
| CharmmFF (System &system, const Options &options)
| CharmmFF (const CharmmFF &force_field)
virtual | ~CharmmFF ()
Assignment
const CharmmFF & | operator= (const CharmmFF &force_field)
virtual void | clear ()
Setup Methods
virtual bool | specificSetup ()
Public Member Functions inherited from BALL::ForceField
| ForceField ()
| ForceField (System &system)
| ForceField (System &system, const Options &options)
| ForceField (const ForceField &force_field)
virtual | ~ForceField ()
ForceField & | operator= (const ForceField &force_field)
bool | isValid () const
bool | setup (System &system)
bool | setup (System &system, const Options &options)
void | setMaximumNumberOfErrors (Size nr)
Size | getMaximumNumberOfErrors () const
HashSet< const Atom * > & | getUnassignedAtoms ()
| Get the atoms, for which the force field setup failed.
void | setName (const String &name)
String | getName () const
Size | getNumberOfAtoms () const
Size | getNumberOfMovableAtoms () const
BALL_INLINE const AtomVector & | getAtoms () const
BALL_INLINE System * | getSystem ()
BALL_INLINE const System * | getSystem () const
BALL_INLINE bool | getUseSelection () const
BALL_INLINE void | disableSelection ()
BALL_INLINE void | enableSelection ()
BALL_INLINE bool | isSelectionEnabled () const
ForceFieldParameters & | getParameters ()
Size | countComponents () const
const TimeStamp & | getUpdateTime () const
const TimeStamp & | getSetupTime () const
void | insertComponent (ForceFieldComponent *force_field_component)
void | removeComponent (const ForceFieldComponent *force_field_component)
void | removeComponent (const String &name)
ForceFieldComponent * | getComponent (const Size index) const
ForceFieldComponent * | getComponent (const String &name) const
double | getEnergy () const
double | updateEnergy ()
void | updateForces ()
double | getRMSGradient () const
virtual Size | getUpdateFrequency () const
virtual void | update ()
std::ostream & | error ()

## Accessors specific to the CHARMM force field

String | filename_
bool | parameters_initialized_
double | getStretchEnergy () const
double | getBendEnergy () const
double | getTorsionEnergy () const
double | getImproperTorsionEnergy () const
double | getProperTorsionEnergy () const
double | getNonbondedEnergy () const
double | getESEnergy () const
double | getVdWEnergy () const
double | getSolvationEnergy () const
bool | hasInitializedParameters () const
virtual String | getResults () const
| Get the current results in String form.

## Additional Inherited Members

Public Types inherited from BALL::ForceField
typedef std::vector< std::pair< Atom *, Atom * > > | PairVector
Options | options
PeriodicBoundary | periodic_boundary
void | collectAtoms_ (const System &system)
void | sortSelectedAtomVector_ ()
virtual void | performRequiredUpdates_ ()
System * | system_
AtomVector | atoms_
ForceFieldParameters | parameters_
bool | valid_
String | name_
double | energy_
vector< ForceFieldComponent * > | components_
Size | number_of_movable_atoms_
bool | use_selection_
bool | selection_enabled_
TimeStamp | update_time_stamp_
TimeStamp | setup_time_stamp_
HashSet< const Atom * > | unassigned_atoms_
Size | max_number_of_errors_
Size | number_of_errors_

## Detailed Description

CHARMM force field class.

Definition at line 29 of file charmm.h.

## Constructor & Destructor Documentation

## CharmmFF() [1/4]

BALL::CharmmFF::CharmmFF | ( |  | ) |

Default constructor.

## CharmmFF() [2/4]

BALL::CharmmFF::CharmmFF | ( | System & | system | ) |

Constructor.

## CharmmFF() [3/4]

BALL::CharmmFF::CharmmFF | ( | System & | system,
|  | const Options & | options )

Constructor.

## CharmmFF() [4/4]

BALL::CharmmFF::CharmmFF | ( | const CharmmFF & | force_field | ) |

Copy constructor

## ~CharmmFF()

virtual BALL::CharmmFF::~CharmmFF | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## clear()

virtual void BALL::CharmmFF::clear | ( |  | ) |

virtual

Clear method

Reimplemented from BALL::ForceField.

## getBendEnergy()

double BALL::CharmmFF::getBendEnergy | ( |  | ) | const

Return the angle bend contribution to the total energy

## getESEnergy()

double BALL::CharmmFF::getESEnergy | ( |  | ) | const

Return the electrostatic contribution to the total energy.

## getImproperTorsionEnergy()

double BALL::CharmmFF::getImproperTorsionEnergy | ( |  | ) | const

Return the improper torsion contribution to the total energy.

## getNonbondedEnergy()

double BALL::CharmmFF::getNonbondedEnergy | ( |  | ) | const

Return the nonbonded contribution to the total energy. This energy comprises Van der Waals energy, hydrogen bond energy, and elesctrostatic energy.

## getProperTorsionEnergy()

double BALL::CharmmFF::getProperTorsionEnergy | ( |  | ) | const

Return the proper torsion contribution to the total energy.

## getResults()

virtual String BALL::CharmmFF::getResults | ( |  | ) | const

virtual

Get the current results in String form.

Reimplemented from BALL::ForceField.

## getSolvationEnergy()

double BALL::CharmmFF::getSolvationEnergy | ( |  | ) | const

Return the solvation contribution to the total energy.

## getStretchEnergy()

double BALL::CharmmFF::getStretchEnergy | ( |  | ) | const

Return the bond stretch contribution to the total energy

## getTorsionEnergy()

double BALL::CharmmFF::getTorsionEnergy | ( |  | ) | const

Return the torsion contribution to the total energy. This energy comprises proper and improper torsions.

## getVdWEnergy()

double BALL::CharmmFF::getVdWEnergy | ( |  | ) | const

Return the Van der Waals and hydrogen bond contribution to the total energy.

## hasInitializedParameters()

bool BALL::CharmmFF::hasInitializedParameters | ( |  | ) | const

Return true, if the parameters have already been initialized

## operator=()

const CharmmFF & BALL::CharmmFF::operator= | ( | const CharmmFF & | force_field | ) |

Assignment operator

## specificSetup()

virtual bool BALL::CharmmFF::specificSetup | ( |  | ) |

virtual

Force field specific setup

Exceptions

  BALL::Exception::TooManyErrors |

Reimplemented from BALL::ForceField.

## Member Data Documentation

## filename_

String BALL::CharmmFF::filename_

protected

Definition at line 293 of file charmm.h.

## parameters_initialized_

bool BALL::CharmmFF::parameters_initialized_

protected

Definition at line 295 of file charmm.h.